#<profile4xi profile = "11"/>
# ------------------------------------------------------------------------------------------------
#<program4xi program = "test_public_methods4xi.py">
#<abstract4xi abstract = "tests public_methods4xi"/>
#<verify4xi verification = "10" target = "public_methods4xi.py"/>
#<contextualize4xi context = "process4xi.py; queue4xi.py; pipe4xi.py; lock4xi.py; manager4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'test_public_methods4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys 
import _winapi
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from public_methods4xi import public_methods4xi

from process4xi import Process4Xi
from queue4xi import Queue4Xi
from pipe4xi import Pipe4Xi
from lock4xi import Lock4Xi
from manager4xi import Manager4Xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE',
        'Lock4Xi': 'NACK4TRACE',
        'Manager4Xi': 'NACK4TRACE',
        'public_methods4xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   trace to XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-public-methods-test4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Public Methods in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Public Methods in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-public-methods-test4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Public Methods in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Public Methods in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-public-methods-test4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Public Methods in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Public Methods in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------
          
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "sense" usage = "
#   senses
#">
# -------------------------------------------------------------------------------------------------
def sense(target_param, queue_param, pipe_param,lock_param,dict_param,list_param):
    target_xi2 = target_param
    queue_xi2 = queue_param
    pipe_publisher_channel_xi2 = pipe_param
    lock_xi2 = lock_param
    dict_xi2 = dict_param
    list_xi2 = list_param
    
    
    print("SENSE: ", target_xi2)
    # ---------------------------------------------------------------------------------------------
    # put a message to the queue
    # 
    queue_xi2.put(['DragonXi2_00', target_xi2, 'sensing!']) # puts to its queue
    # ---------------------------------------------------------------------------------------------
    # reserve the pipe using the lock, send messages and release the pipe
    # 
    lock_xi2.acquire()

    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_01', 'BIO ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_02', 'CO2 ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_03', 'Coal ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_04', 'Diesel ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_05', 'Electricity ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_06', 'Fusion ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_07', 'Gas ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_08', 'Geo ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_09', 'Hydrogen ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_10', 'Lithium ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_11', 'Nuclear Power ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_12', 'Ocean ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_13', 'Oil ',target_xi2]) 
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_14', 'Solar ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_15', 'Wind ',target_xi2])
    
    dict_xi2[1] = "BIO"
    dict_xi2[2] = "CO2"
    dict_xi2[3] = "Coal"
    dict_xi2[4] = "Diesel"
    dict_xi2[5] = "Electricity"
    dict_xi2[6] = "Fusion"
    dict_xi2[7] = "Gas"
    dict_xi2[8] = "Geo"
    dict_xi2[9] = "Hydrogen"
    dict_xi2[10] = "Lithium"
    dict_xi2[11] = "Nuclear Power"
    dict_xi2[12] = "Ocean"
    dict_xi2[13] = "Oil"
    dict_xi2[14] = "Solar"
    dict_xi2[15] = "Wind"
    

    lock_xi2.release()       
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "test1" usage = "
#   testing public methods
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#"> 
# -------------------------------------------------------------------------------------------------    
def test1():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0/14) OF TEST_PUBLIC METHODS4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
    
        print('=' *33)
        print("\n (STEP 1/14) OF TEST PUBLIC METHODS4XI: CREATING QUEUE4XI ", time4xi())         
        print('=' *33)
        # 02:45:09 01/15/13 Pacific Standard Time
        
        queue2xi = Queue4Xi()
        print("\n QUEUE2XI METHODS: ", public_methods4xi(queue2xi))
        # ['ace', 'cancel_join_thread', 'close', 'empty', 'full', 'get', 'get_nowait', 'join_thread', 'put', 'put_nowait', 'qsize', 'reason', 'sense']
        
        print('=' *33)
        print("\n (STEP 2/14) OF TEST PUBLIC METHODS4XI: CREATING PIPE4XI ", time4xi())   
        print('=' *33)
        # 02:45:09 01/15/13 Pacific Standard Time
        
        pipe2xi_consumer_channel, pipe2xi_publisher_channel = Pipe4Xi()
        print("\n PIPE2XI_CONSUMER_CHANNEL METHODS: ", public_methods4xi(pipe2xi_consumer_channel))
        # ['ace', 'close', 'fileno', 'poll', 'reason', 'recv', 'recv_bytes', 'recv_bytes_into', 'send', 'send_bytes', 'sense']
        
        print("\n PIPE2XI_PUBLISHER_CHANNEL METHODS: ", public_methods4xi(pipe2xi_publisher_channel))    
        # ['ace', 'close', 'fileno', 'poll', 'reason', 'recv', 'recv_bytes', 'recv_bytes_into', 'send', 'send_bytes', 'sense']
        
        print('=' *33)
        print("\n (STEP 3/14) OF TEST PUBLIC METHODS4XI: CREATING LOCK4XI ", time4xi())     
        print('=' *33)
        # 02:45:09 01/15/13 Pacific Standard Time
        
        lock_xi2 = Lock4Xi()
        print("\n LOCK_XI2 METHODS: ", public_methods4xi(lock_xi2))
        # ['ace', 'acquire', 'reason', 'release', 'sense']
        
        print('=' *33)
        print("\n (STEP 4/14) OF TEST PUBLIC METHODS4XI: CREATING MANAGER4XI ", time4xi())   
        print('=' *33)
        # 02:45:09 01/15/13 Pacific Standard Time
        
        manager2xi = Manager4Xi()
        print("\n MANAGER2XI METHODS: ", public_methods4xi(manager2xi))
        # ['Array', 'Barrier', 'BoundedSemaphore', 'Condition', 'Event', 'JoinableQueue', 
        # 'Lock', 'Namespace', 'Pool', 'Queue', 'RLock', 'Semaphore', 'Value', 'connect', 
        # 'dict', 'get_server', 'join', 'list', 'register', 'shutdown', 'start']
        

        print('=' *33)
        print("\n (STEP 5/14) OF TEST PUBLIC METHODS4XI: CREATING DICTIONARY WITH MANAGER4XI ", time4xi())   
        print('=' *33)
        # 02:45:09 01/15/13 Pacific Standard Time
            
        dict2xi = manager2xi.dict()
    
        print('=' *33)
        print("\n (STEP 6/14) OF TEST PUBLIC METHODS4XI: CREATING LIST WITH MANAGER4XI ", time4xi())   
        print('=' *33)
        # 02:45:09 01/15/13 Pacific Standard Time
        
        list2xi = manager2xi.list(range(15))
    
        print('=' *33)
        print("\n (STEP 7/14) OF TEST PUBLIC METHODS4XI: CREATING PROCESS4XI ", time4xi())    
        print('=' *33)
        # 02:45:09 01/15/13 Pacific Standard Time
        
        process2xi = Process4Xi(target=sense, args=('Energy ',queue2xi, pipe2xi_publisher_channel,lock_xi2,dict2xi,list2xi))
        print("\n PROCESS2XI METHODS: ", public_methods4xi(process2xi))
        # ['ace', 'is_alive', 'join', 'reason', 'run', 'sense', 'start', 'terminate'] 
        
        print('=' *33)
        print("\n (STEP 8A/14) OF TEST PUBLIC METHODS4XI: STARTING PROCESS4XI ", time4xi())        
        print('=' *33)
        # 03:04:32 01/15/13 Pacific Standard Time
        try:
            process2xi.start()
        except:
            print("\n (STEP 8Z1/14) OF TEST PUBLIC METHODS4XI *** FAILED STARTING PROCESS4XI *** ", time4xi()) 
        
        print('=' *33)
        print("\n (STEP 8B/14) OF TEST PUBLIC METHODS4XI: RUNNING PROCESS4XI ", time4xi()) 
        print('=' *33)
        # 03:04:32 01/15/13 Pacific Standard Time
        try:
            process2xi.run()
        except:
            print("\n (STEP 8Z2/14) OF TEST PUBLIC METHODS4XI *** FAILED RUNNING PROCESS4XI *** ", time4xi())       
           
        print("\n (STEP 8C/14) OF TEST PUBLIC METHODS4XI: CHECKING WHETHER PROCESS IS ALIVE ", time4xi())  
        # 03:04:32 01/15/13 Pacific Standard Time    
        try:        
            print ("PROCESS2XI ALIVE STATUS OF TEST PUBLIC METHODS4XI: ", process2xi.is_alive())       # check whether the process is alive
            # True
        except:
            print("\n (STEP 8Z3/14) OF TEST PUBLIC METHODS4XI *** FAILED CHECKING WHETHER PROCESS IS ALIVE *** ", time4xi()) 
                    
        print("\n (STEP 8D/14) OF TEST PUBLIC METHODS4XI: CHECKING PROCESS NAME ", time4xi()) 
        try:  
            print ("PROCESS2XI NAME OF TEST PUBLIC METHODS4XI: ", process2xi.name)                     # the name of the process
            # Process4Xi-1
        except:
            print("\n (STEP 8Z4/14) OF TEST PUBLIC METHODS4XI *** FAILED CHECKING PROCESS NAME *** ",  time4xi()) 
        
        print("\n (STEP 8E/14) OF TEST PUBLIC METHODS4XI: CHECKING PROCESS IDENTITY ",  time4xi()) 
        try:  
            print ("PROCESS2XI PID OF TEST PUBLIC METHODS4XI: ", process2xi.ident)                     # pid = ident of the process
            # 776
        except:
            print("\n (STEP 8Z5/14) OF TEST PUBLIC METHODS4XI *** FAILED CHECKING PROCESS IDENTITY *** ",  time4xi()) 
        print("\n (STEP 8F/14) OF TEST PUBLIC METHODS4XI: CHECKING PROCESS AUTHORIZATION ", time4xi())
        try:                   
            print ("PROCESS2XI AUTHENTICATION KEY OF TEST PUBLIC METHODS4XI: ", process2xi.authkey)    # authorization key given by the system
            # b'\x15\x85\xf0zdk2\xa0\xef\xe6\x1a\xd5\xc2d\x8e\xf8\xfa\x95\xed\xc5\xb2+iw\xac,\xc1\xf4\xfd\xa7\x99\xc4'
        except:
            print("\n (STEP 8Z6/14) OF TEST PUBLIC METHODS4XI *** FAILED CHECKING PROCESS AUTHORIZATION *** ",  time4xi()) 
        
            
        print('=' *33)
        print("\n (STEP 9/14) OF TEST PUBLIC METHODS4XI: GETTING FROM QUEUE ", time4xi())      
        print('=' *33)
        
        print (queue2xi.get())
        # ['DragonXi2_00', 'Energy ', 'sensing!']
    
        print('=' *33)
        print("\n (STEP 10/14) OF TEST PUBLIC METHODS4XI: RECEIVING FROM PIPE ", time4xi()) 
        print('=' *33)
        
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        # =================================
        # ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
        # ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
        # ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
        # ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
        # ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
        # ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
        # ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
        # ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
        # ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
        # ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
        # ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
        # ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
        # ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
        # ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
        # ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
        # =================================     
        
        print('=' *33)
        print("\n (STEP 11/14) OF TEST PUBLIC METHODS - DICTIONARY CREATED BY MANAGER2XI AND UPDATED BY PROCESS2XI: ", time4xi())       
        print('=' *33)
        
        print (dict2xi) 
        # {1: 'BIO', 2: 'CO2', 3: 'Coal', 4: 'Diesel', 5: 'Electricity', 6: 'Fusion', 7: 'Gas', 8: 'Geo', 9: 'Hydrogen', 
        #  10: 'Lithium', 11: 'Nuclear Power', 12: 'Ocean', 13: 'Oil', 14: 'Solar', 15: 'Wind'}
        
        print('=' *33)
        print("\n (STEP 12/14) OF TEST PUBLIC METHODS - LIST FOR MANAGER2XI AND PROCESS2XI: ", time4xi())  
        print('=' *33)
        
        print (list2xi)
        # [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
        
        print('=' *33) 
        print("\n (STEP 13/14) OF TEST PUBLIC METHODS4XI: JOINING PROCESS ", time4xi())  
        print('=' *33)
        # 03:04:32 01/15/13 Pacific Standard Time
        
        process2xi.join()
        
    
        print('=' *33)
        print("\n (STEP 14/14) OF TEST PUBLIC METHODS - PROCESS2XI EXIT CODE AFTER JOIN  ", time4xi())  
        print('=' *33)
        
        print (process2xi.exitcode) # see how the process did exit       
        # 0
    except:
        pass
    finally:
        # ---------------------------------------------------------------------------------------------    
        # PRINT TRACE
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)           
#</function4xi>

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   testing public methods
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">                       
# -------------------------------------------------------------------------------------------------    
def main():
    
    test1()
#</function4xi>

            
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()


#</program4xi>
# -------------------------------------------------------------------------------------------------
# History of public_methods4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_public_methods4xi.txt
#   sense-public-methods-test4xi.xml
#   reason-public-methods-test4xi.xml
#   ace-public-methods-test4xi.xml

# 
# queue2xi methods:  ['ace', 'cancel_join_thread', 'close', 'empty', 'full', 'get', 'get_nowait', 'join_thread', 'put', 'put_nowait', 'qsize', 'reason', 'sense']
# 
# pipe2xi_consumer_channel methods:  ['close', 'fileno', 'poll', 'recv', 'recv_bytes', 'recv_bytes_into', 'send', 'send_bytes']
# 
# pipe2xi_publisher_channel methods:  ['close', 'fileno', 'poll', 'recv', 'recv_bytes', 'recv_bytes_into', 'send', 'send_bytes']
# 
# lock_xi2 methods:  ['ace', 'acquire', 'reason', 'release', 'sense']
# 
# manager2xi methods:  ['Array', 'BoundedSemaphore', 'Condition', 'Event', 'JoinableQueue', 'Lock', 'Namespace', 'Pool', 'Queue', 'RLock', 'Semaphore', 'Value', 'connect', 'dict', 'get_server', 'join', 'list', 'register', 'shutdown', 'start']
# 
# process2xi methods:  ['ace', 'is_alive', 'join', 'reason', 'run', 'sense', 'start', 'terminate']
# process2xi alive status:  True
# process2xi name:  Process4Xi-2
# process2xi PID:  3324
# process2xi authentication key:  b'\x80\x99!\xaf\x8d\xcf\xa4\xfa\xe1\xd7\x04[\x8eV\xad\xa8\x94P\xe3+p\xe4I\x8b\x03\x14\x84\xf2\x89&f\x07'
# ['DragonXi2_00', 'Energy ', 'sensing!']
# ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
# ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
# ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
# ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
# ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
# ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
# ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
# ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
# ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
# ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
# ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
# ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
# ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
# ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
# ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
# 
#  Dictionary created by manager2xi and updated by process2xi:
# {1: 'BIO', 2: 'CO2', 3: 'Coal', 4: 'Diesel', 5: 'Electricity', 6: 'Fusion', 7: 'Gas', 8: 'Geo', 9: 'Hydrogen'}
# 
#  List for manager2xi and process2xi:
# [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
# process2xi exit code after join :  0
# 

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
    
# -------------------------------------------------------------------------------------------------
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_public_methods4xi.py                          
# ------------------------------------------------------------------------------------------------- 
#"
#/>